diff --git a/controller/ovn-controller.c b/controller/ovn-controller.c
index c48667887..6bb8f07db 100644
--- a/controller/ovn-controller.c
+++ b/controller/ovn-controller.c
@@ -5363,6 +5363,7 @@ main(int argc, char *argv[])
     /* Main loop. */
     bool sb_monitor_all = false;
     while (!exit_args.exiting) {
+        bool recompute_allowed = true;
         memory_run();
         if (memory_should_report()) {
             struct simap usage = SIMAP_INITIALIZER(&usage);
@@ -5536,34 +5537,34 @@ main(int argc, char *argv[])
 
                     stopwatch_start(CONTROLLER_LOOP_STOPWATCH_NAME,
                                     time_msec());
-                    if (ovnsb_idl_txn) {
-                        if (ofctrl_has_backlog()) {
-                            /* When there are in-flight messages pending to
-                             * ovs-vswitchd, we should hold on recomputing so
-                             * that the previous flow installations won't be
-                             * delayed.  However, we still want to try if
-                             * recompute is not needed and we can quickly
-                             * incrementally process the new changes, to avoid
-                             * unnecessarily forced recomputes later on.  This
-                             * is because the OVSDB change tracker cannot
-                             * preserve tracked changes across iterations.  If
-                             * change tracking is improved, we can simply skip
-                             * this round of engine_run and continue processing
-                             * acculated changes incrementally later when
-                             * ofctrl_has_backlog() returns false. */
-                            engine_run(false);
-                        } else {
-                            engine_run(true);
-                        }
-                    } else {
+                    if (!ovnsb_idl_txn || ofctrl_has_backlog()) {
+                        /* No ovnsb_idl_txn  */
                         /* Even if there's no SB DB transaction available,
-                         * try to run the engine so that we can handle any
-                         * incremental changes that don't require a recompute.
-                         * If a recompute is required, the engine will cancel,
-                         * triggerring a full run in the next iteration.
-                         */
-                        engine_run(false);
+                        * try to run the engine so that we can handle any
+                        * incremental changes that don't require a recompute.
+                        * If a recompute is required, the engine will cancel,
+                        * triggerring a full run in the next iteration.
+                        */
+
+                        /* OR */
+
+                        /* ofctrl_has_backlog */
+                        /* When there are in-flight messages pending to
+                         * ovs-vswitchd, we should hold on recomputing so
+                         * that the previous flow installations won't be
+                         * delayed.  However, we still want to try if
+                         * recompute is not needed and we can quickly
+                         * incrementally process the new changes, to avoid
+                         * unnecessarily forced recomputes later on.  This
+                         * is because the OVSDB change tracker cannot
+                         * preserve tracked changes across iterations.  If
+                         * change tracking is improved, we can simply skip
+                         * this round of engine_run and continue processing
+                         * acculated changes incrementally later when
+                         * ofctrl_has_backlog() returns false. */
+                        recompute_allowed = false;
                     }
+                    engine_run(recompute_allowed);
                     stopwatch_stop(CONTROLLER_LOOP_STOPWATCH_NAME,
                                    time_msec());
                     if (engine_has_updated()) {
@@ -5685,7 +5686,9 @@ main(int argc, char *argv[])
                         }
                     }
 
-                    if (mac_cache_data) {
+                    if (mac_cache_data && recompute_allowed) {
+                        /* Run only when engine recompute is allowed
+                         * since mac_binding/FDB rows are cached */
                         statctrl_run(ovnsb_idl_txn, mac_cache_data);
                     }
 